#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK0x0x0TT1x1x1_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const float *stM = A + (((lda*Mb) << 1));
   const float *stN = B + (((Nb) << 1));
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 2
   const int incAm = ((((lda) - Kb) << 1)), incAn = -(((Mb*lda) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(((Kb*ldb) << 1));
   #define incBn 2
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=0; k < K; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            pA0 += incAk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK0x0x0TT1x1x12_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=12, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const int Kloop = ((K-2)/12)*12, kr = K - Kloop - 2;
   const float *stM = A + (((lda*Mb) << 1));
   const float *stN = B + (((Nb) << 1));
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 24
   const int incAm = ((((lda) - Kb) << 1)), incAn = -(((Mb*lda) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(((Kb*ldb) << 1));
   #define incBn 2
   const int incAk0 = ((incAk) / 12);
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float m0;
   register float rC0_0;
   if (K < 3)
   {
      ATL_cJIK0x0x0TT1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         pB0 += incBk0;
         rA0 = pA0[2];
         rB0 = *pB0;

         pA0 += (incAk0);
         for (k=0; k < Kloop; k += 12) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[24];
            rB0 = *pB0;
            pA0 += incAk;
         } /* end K-loop */
         switch(kr)
         {
         case 1:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            pA0 += (incAk0);
            break;
         case 2:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            pA0 += (((incAk0) << 1));
            break;
         case 3:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            pA0 += (((incAk0) << 1)+incAk0);
            break;
         case 4:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            pA0 += (((incAk0) << 2));
            break;
         case 5:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            pA0 += (((incAk0) << 2)+incAk0);
            break;
         case 6:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            pA0 += (((incAk0) << 2)+((incAk0) << 1));
            break;
         case 7:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            pA0 += (7*(incAk0));
            break;
         case 8:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            pA0 += (((incAk0) << 3));
            break;
         case 9:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            pA0 += (((incAk0) << 3)+incAk0);
            break;
         case 10:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            pA0 += (((incAk0) << 3)+((incAk0) << 1));
            break;
         case 11:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[10];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[12];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[14];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[16];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[18];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[20];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[22];
            rB0 = *pB0;
            pA0 += (11*(incAk0));
            break;
         case 0: ;
         }
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         pB0 += incBk0;
         rC0_0 += m0;
         pA0 += incAk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK0x0x0TT0x0x0_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=1, ku=12, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>2)<<2;
   #define Nb N
   #define Kb K
   const int Kloop = ((K-1)/12)*12, kr = K - Kloop - 1;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((lda*Mb) << 1));
   const float *stN = B + (((Nb) << 1));
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 24
   const int incAm = ((((((lda) << 2)) - Kb) << 1)), incAn = -(((Mb*lda) << 1));
   const int incBk = (((ldb) << 1)), incBm = -(((Kb*ldb) << 1));
   #define incBn 2
   const int incAk0 = ((incAk) / 12);
   #define incBk0 incBk
   #define incCm 8
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C;
   const float *pA0=A, *pA1=pA0+(((lda) << 1)), *pA2=pA1+(((lda) << 1)), *pA3=pA2+(((lda) << 1));
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0;
   register float m0, m1;
   register float rC0_0, rC1_0, rC2_0, rC3_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[2];
            rC1_0 *= rA0;
            rC2_0 = pC0[4];
            rC2_0 *= rA0;
            rC3_0 = pC0[6];
            rC3_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = *pA1;
            m0 = rA0 * rB0;
            rA2 = *pA2;
            rA3 = *pA3;
            m1 = rA1 * rB0;

            for (k=0; k < Kloop; k += 12) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rA2 = pA2[12];
               rA3 = pA3[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rA2 = pA2[14];
               rA3 = pA3[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rA2 = pA2[16];
               rA3 = pA3[16];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rA2 = pA2[18];
               rA3 = pA3[18];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rA2 = pA2[20];
               rA3 = pA3[20];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rA2 = pA2[22];
               rA3 = pA3[22];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[24];
               rB0 = *pB0;
               rA1 = pA1[24];
               rA2 = pA2[24];
               rA3 = pA3[24];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pA1 += incAk;
               pA2 += incAk;
               pA3 += incAk;
            } /* end K-loop */
            switch(kr)
            {
            case 1:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (incAk0);
               pA1 += (incAk0);
               pA2 += (incAk0);
               pA3 += (incAk0);
               break;
            case 2:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 1));
               pA1 += (((incAk0) << 1));
               pA2 += (((incAk0) << 1));
               pA3 += (((incAk0) << 1));
               break;
            case 3:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 1)+incAk0);
               pA1 += (((incAk0) << 1)+incAk0);
               pA2 += (((incAk0) << 1)+incAk0);
               pA3 += (((incAk0) << 1)+incAk0);
               break;
            case 4:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 2));
               pA1 += (((incAk0) << 2));
               pA2 += (((incAk0) << 2));
               pA3 += (((incAk0) << 2));
               break;
            case 5:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 2)+incAk0);
               pA1 += (((incAk0) << 2)+incAk0);
               pA2 += (((incAk0) << 2)+incAk0);
               pA3 += (((incAk0) << 2)+incAk0);
               break;
            case 6:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rA2 = pA2[12];
               rA3 = pA3[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 2)+((incAk0) << 1));
               pA1 += (((incAk0) << 2)+((incAk0) << 1));
               pA2 += (((incAk0) << 2)+((incAk0) << 1));
               pA3 += (((incAk0) << 2)+((incAk0) << 1));
               break;
            case 7:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rA2 = pA2[12];
               rA3 = pA3[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rA2 = pA2[14];
               rA3 = pA3[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (7*(incAk0));
               pA1 += (7*(incAk0));
               pA2 += (7*(incAk0));
               pA3 += (7*(incAk0));
               break;
            case 8:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rA2 = pA2[12];
               rA3 = pA3[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rA2 = pA2[14];
               rA3 = pA3[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rA2 = pA2[16];
               rA3 = pA3[16];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 3));
               pA1 += (((incAk0) << 3));
               pA2 += (((incAk0) << 3));
               pA3 += (((incAk0) << 3));
               break;
            case 9:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rA2 = pA2[12];
               rA3 = pA3[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rA2 = pA2[14];
               rA3 = pA3[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rA2 = pA2[16];
               rA3 = pA3[16];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rA2 = pA2[18];
               rA3 = pA3[18];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 3)+incAk0);
               pA1 += (((incAk0) << 3)+incAk0);
               pA2 += (((incAk0) << 3)+incAk0);
               pA3 += (((incAk0) << 3)+incAk0);
               break;
            case 10:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rA2 = pA2[12];
               rA3 = pA3[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rA2 = pA2[14];
               rA3 = pA3[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rA2 = pA2[16];
               rA3 = pA3[16];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rA2 = pA2[18];
               rA3 = pA3[18];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rA2 = pA2[20];
               rA3 = pA3[20];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 3)+((incAk0) << 1));
               pA1 += (((incAk0) << 3)+((incAk0) << 1));
               pA2 += (((incAk0) << 3)+((incAk0) << 1));
               pA3 += (((incAk0) << 3)+((incAk0) << 1));
               break;
            case 11:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[6];
               rB0 = *pB0;
               rA1 = pA1[6];
               rA2 = pA2[6];
               rA3 = pA3[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[8];
               rB0 = *pB0;
               rA1 = pA1[8];
               rA2 = pA2[8];
               rA3 = pA3[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[10];
               rB0 = *pB0;
               rA1 = pA1[10];
               rA2 = pA2[10];
               rA3 = pA3[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[12];
               rB0 = *pB0;
               rA1 = pA1[12];
               rA2 = pA2[12];
               rA3 = pA3[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[14];
               rB0 = *pB0;
               rA1 = pA1[14];
               rA2 = pA2[14];
               rA3 = pA3[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[16];
               rB0 = *pB0;
               rA1 = pA1[16];
               rA2 = pA2[16];
               rA3 = pA3[16];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[18];
               rB0 = *pB0;
               rA1 = pA1[18];
               rA2 = pA2[18];
               rA3 = pA3[18];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[20];
               rB0 = *pB0;
               rA1 = pA1[20];
               rA2 = pA2[20];
               rA3 = pA3[20];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               pB0 += incBk;
               rA0 = pA0[22];
               rB0 = *pB0;
               rA1 = pA1[22];
               rA2 = pA2[22];
               rA3 = pA3[22];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (11*(incAk0));
               pA1 += (11*(incAk0));
               pA2 += (11*(incAk0));
               pA3 += (11*(incAk0));
               break;
            case 0: ;
            }
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA2 * rB0;
            rC1_0 += m1;
            m1 = rA3 * rB0;
            pB0 += incBk0;
            rC2_0 += m0;
            rC3_0 += m1;
            pA0 += incAk0;
            pA1 += incAk0;
            pA2 += incAk0;
            pA3 += incAk0;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            rC2_0 *= rB0;
            rC3_0 *= rB0;
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0[4] = rC2_0;
            pC0[6] = rC3_0;
            pC0 += incCm;
            pA0 += incAm;
            pA1 += incAm;
            pA2 += incAm;
            pA3 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pA1 += incAn;
         pA2 += incAn;
         pA3 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_cJIK0x0x0TT1x1x12_aX_bX(k, N, K, alpha, ca + (((Mb*lda) << 1)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
